%% CorrelationPlot
disp('Creating Figure 3')
% Figure 3 - correlation plot
MarkerID = {'o' '^'};
MarkerSize = 4;
Colors{1,1 } = Exp.color{1};
Colors{2,1} = Exp.color{2};
Colors{1,2} = (Exp.color{1} + [1 1 1])/2;
Colors{2,2} = (Exp.color{2} + [1 1 1])/2;
%Metrics are structured as (sub,cond,Vn,Cn,rep)
figure();

% % Mean ECO - Mean Fuel consumption /s
subplot(1,3,1); hold on;
labels = {'Mean eco-score (%)' 'Mean fuelconsumption (cm^3/km)'};

for Cn = 1:2
    for cond = 1:2
        PlotX = reshape(Metrics.ECO.mean(:,cond,:,Cn,:),[14560,1]);
        PlotY = reshape(Metrics.FuelConsumptionPerKm.mean(:,cond,:,Cn,:),[14560,1]);
        plot(PlotX,PlotY,'color',Colors{cond,Cn},'Marker',MarkerID{Cn},'LineStyle','none','MarkerSize',MarkerSize)
    end
end
X_tot = reshape(Metrics.ECO.mean,[91*2*2*2*80,1]);
Y_tot = reshape(Metrics.FuelConsumptionPerKm.mean,[91*2*2*2*80,1]);
X_tot = X_tot(~isnan(X_tot));
Y_tot = Y_tot(~isnan(Y_tot));
RHO_total = corr(X_tot,Y_tot,'type','spearman');
text( 0.05,1 - 0.5/25,' \it{\rho}','Units','normalized')
text( 0.15,1 - 0.5/25,['= ' num2str(round(RHO_total,2))],'Units','normalized');
xlabel(labels{1});
ylabel(labels{2});
set(gca, 'XDir','reverse')
xlim([40 100])

subplot(1,3,2); hold on;
labels = {'Mean (v*a_x)^2' 'Mean fuelconsumption (cm^3/km)'};

for Cn = 1:2
    for cond = 1:2
        PlotX = reshape(Metrics.va2.mean(:,cond,:,Cn,:),[14560,1]);
        PlotY = reshape(Metrics.FuelConsumptionPerKm.mean(:,cond,:,Cn,:),[14560,1]);
        plot(PlotX,PlotY,'color',Colors{cond,Cn},'Marker',MarkerID{Cn},'LineStyle','none','MarkerSize',MarkerSize)
    end
end
X_tot = reshape(Metrics.va2.mean,[91*2*2*2*80,1]);
Y_tot = reshape(Metrics.FuelConsumptionPerKm.mean,[91*2*2*2*80,1]);
X_tot = X_tot(~isnan(X_tot));
Y_tot = Y_tot(~isnan(Y_tot));
RHO_total = corr(X_tot,Y_tot,'type','spearman');
text( 0.05,1 - 0.5/25,' \it{\rho}','Units','normalized')
text( 0.15,1 - 0.5/25,['= ' num2str(round(RHO_total,2))],'Units','normalized');
legend({'Normal_{HW}' 'Eco_{HW}'...
    'Normal_{MT}' 'Eco_{MT}'},...
    'Location','best','Orientation','horizontal')
xlabel(labels{1});
ylabel(labels{2});

subplot(1,3,3); hold on;
labels = {'SD throttle (%)' 'Mean fuelconsumption (cm^3/km)'};
for Cn = 1:2
    for cond = 1:2
        PlotX = reshape(Metrics.GP.std(:,cond,:,Cn,:),[14560,1]);
        PlotY = reshape(Metrics.FuelConsumptionPerKm.mean(:,cond,:,Cn,:),[14560,1]);
        plot(PlotX,PlotY,'color',Colors{cond,Cn},'Marker',MarkerID{Cn},'LineStyle','none','MarkerSize',MarkerSize)
    end
end
X_tot = reshape(Metrics.GP.std,[91*2*2*2*80,1]);
Y_tot = reshape(Metrics.FuelConsumptionPerKm.mean,[91*2*2*2*80,1]);
X_tot = X_tot(~isnan(X_tot));
Y_tot = Y_tot(~isnan(Y_tot));
RHO_total = corr(X_tot,Y_tot,'type','spearman');
text( 0.05,1 - 0.5/25,' \it{\rho}','Units','normalized')
text( 0.15,1 - 0.5/25,['= ' num2str(round(RHO_total,2))],'Units','normalized');
xlabel(labels{1});
ylabel(labels{2});
xlim([0.1 55])
  fig=gcf;set(findall(fig,'-property','FontName'),'FontName','Arial','Fontsize',12)