function DataOut = CreateValues(spss, Exp)
%Put the values in a structure that can easily handled by the plot
%statistics function
Fs = 100; % Sample freq

for Vn = 1:2
    DataIn = spss.Vehicle(Vn); % Vn = 1 is megane Vn = 2
    
    % INIT
    max = 80;
    NrSub = length(DataIn.sub);
    HW.Mean_ECO = nan(NrSub,2,max); %sub,cond,rep
    HW.Mean_abs_SWA = nan(NrSub,2,max); %sub,cond,rep
    HW.SRR = nan(NrSub,2,max); %sub,cond,rep
    HW.Speed = nan(NrSub,2,max); %sub,cond,rep
    HW.Speed_SD = nan(NrSub,2,max); %sub,cond,rep
    HW.GRR = nan(NrSub,2,max); %sub,cond,rep
    HW.BRR = nan(NrSub,2,max); %sub,cond,rep
    HW.p75_abs_LongAcc = nan(NrSub,2,max); %sub,cond,rep
    HW.p75_abs_LatACC = nan(NrSub,2,max); %sub,cond,rep
    HW.Mean_abs_SWA_speed = nan(NrSub,2,max); %sub,cond,rep
    HW.p50_abs_SWA_speed = nan(NrSub,2,max); %sub,cond,rep
    HW.p50_SWA_speed = nan(NrSub,2,max); %sub,cond,rep
    HW.p10_abs_SWA_speed = nan(NrSub,2,max); %sub,cond,rep
    HW.Brake_SD = nan(NrSub,2,max); %sub,cond,rep
    HW.SWA_SD = nan(NrSub,2,max); %sub,cond,rep
    HW.GP_SD = nan(NrSub,2,max); %sub,cond,rep
    HW.GP = nan(NrSub,2,max); %sub,cond,rep
    HW.p99_BP = nan(NrSub,2,max); %sub,cond,rep
    HW.LongAcc_SD = nan(NrSub,2,max); %sub,cond,rep
    HW.LatAcc_SD = nan(NrSub,2,max); %sub,cond,rep
    HW.GP_percentage_above_90 = nan(NrSub,2,max);
    HW.p90_GP = nan(NrSub,2,max); %sub,cond,rep
    HW.Mean_FuelConsumption_psec = nan(NrSub,2,max);
    HW.Mean_FuelConsumption_pkm = nan(NrSub,2,max);
    HW.Total_FuelConsumption = nan(NrSub,2,max);
    HW.RPA = nan(NrSub,2,max);
    HW.VA_mean = nan(NrSub,2,max);
    HW.VA_squared_mean = nan(NrSub,2,max);
    HW.perc_abs_Acc_LargerThan_2_5 = nan(NrSub,2,max);
    HW.perc_Speed_LT_110 = nan(NrSub,2,max);
    HW.EngineRPM_Mean = nan(NrSub,2,max);
    
    MT = HW;
    
    for cond = 1:length(Exp.condition)
        for sub = 1:length(DataIn.sub)
            NumHW_Sections = length(DataIn.sub(sub).cond(cond).Sections.Highway);
            if ~isempty(NumHW_Sections)
                for rep = 1:NumHW_Sections
                    HW.Mean_ECO(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Highway{rep}.ECO.mean;
                    HW.Mean_abs_SWA(sub,cond,rep) = mean(abs(DataIn.sub(sub).cond(cond).Sections.Highway{rep}.SWA.raw));
                    HW.SRR(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Highway{rep}.SWA.reversal_rate;
                    HW.Speed(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Highway{rep}.Speed.mean;
                    HW.Speed_SD(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Highway{rep}.Speed.std;
                    HW.GRR(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Highway{rep}.GP.reversal_rate;
                    HW.BRR(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Highway{rep}.BrakePressure.reversal_rate;
                    HW.p75_abs_LongAcc(sub,cond,rep) = prctile(abs(DataIn.sub(sub).cond(cond).Sections.Highway{rep}.LongAcc.raw),75);
                    HW.p75_abs_LatACC(sub,cond,rep) = prctile(abs(DataIn.sub(sub).cond(cond).Sections.Highway{rep}.LatAcc.raw),75);
                    %HW.LongAccRR(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Highway{rep}.LongAcc.reversal_rate;
                    HW.Mean_abs_SWA_speed(sub,cond,rep) = mean(abs(DataIn.sub(sub).cond(cond).Sections.Highway{rep}.SWA_Speed.raw));
                    HW.p50_abs_SWA_speed(sub,cond,rep) = prctile(abs(DataIn.sub(sub).cond(cond).Sections.Highway{rep}.SWA_Speed.raw),50);
                    HW.p50_SWA_speed(sub,cond,rep) = prctile(DataIn.sub(sub).cond(cond).Sections.Highway{rep}.SWA_Speed.raw,50);
                    
                    HW.p10_abs_SWA_speed(sub,cond,rep) = prctile(abs(DataIn.sub(sub).cond(cond).Sections.Highway{rep}.SWA_Speed.raw),10);
                    
                    HW.Brake_SD(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Highway{rep}.BrakePressure.std;
                    HW.SWA_SD(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Highway{rep}.SWA.std;
                    HW.GP_SD(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Highway{rep}.GP.std;
                    
                    HW.GP(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Highway{rep}.GP.mean;
                    HW.p99_BP(sub,cond,rep) = prctile(abs(DataIn.sub(sub).cond(cond).Sections.Highway{rep}.BrakePressure.raw),99);
                    HW.LongAcc_SD(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Highway{rep}.LongAcc.std;
                    HW.LatAcc_SD(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Highway{rep}.LatAcc.std;
                    HW.GP_percentage_above_90(sub,cond,rep) = length(find(DataIn.sub(sub).cond(cond).Sections.Highway{rep}.GP.raw > 90))...
                        /length(DataIn.sub(sub).cond(cond).Sections.Highway{rep}.GP.raw)*100;
                    HW.p90_GP(sub,cond,rep) = prctile(abs(DataIn.sub(sub).cond(cond).Sections.Highway{rep}.GP.raw),90);
                                       
                    % OLD FUEL CONSUMPTION CALCULATION
%                     % Fuel consumption psec
%                     HW.Mean_FuelConsumption_psec(sub,cond,rep) = (sum(DataIn.sub(sub).cond(cond).Sections.Highway{rep}.FuelConsumption.raw)./...
%                         (length(DataIn.sub(sub).cond(cond).Sections.Highway{rep}.FuelConsumption_diff.raw)/Fs))/1000; % mm^3 --> cm^3
%                     
%                          % Fuel Consumption pkm
%                     HW.Mean_FuelConsumption_pkm(sub,cond,rep) = (sum(DataIn.sub(sub).cond(cond).Sections.Highway{rep}.FuelConsumption.raw)./...
%                         DataIn.sub(sub).cond(cond).Sections.Highway{rep}.DistanceTravelled.raw(end))/1000; % mm^3 --> cm^3
% 
%                     HW.Total_FuelConsumption(sub,cond,rep) = (sum(DataIn.sub(sub).cond(cond).Sections.Highway{rep}.FuelConsumption.raw))/1000; % mm^3 --> cm^3;
%                     

%                     % Fuel consumption psec
                    HW.Mean_FuelConsumption_psec(sub,cond,rep) = (DataIn.sub(sub).cond(cond).Sections.Highway{rep}.FuelConsumption_Cum.raw(end)./...
                        (length(DataIn.sub(sub).cond(cond).Sections.Highway{rep}.FuelConsumption_raw.raw)/Fs))/1000; % mm^3 --> cm^3
                    
                         % Fuel Consumption pkm
                    HW.Mean_FuelConsumption_pkm(sub,cond,rep) = (DataIn.sub(sub).cond(cond).Sections.Highway{rep}.FuelConsumption_Cum.raw(end)./...
                        DataIn.sub(sub).cond(cond).Sections.Highway{rep}.DistanceTravelled.raw(end))/1000; % mm^3 --> cm^3

                    HW.Total_FuelConsumption(sub,cond,rep) = (DataIn.sub(sub).cond(cond).Sections.Highway{rep}.FuelConsumption_Cum.raw(end))/1000; % mm^3 --> cm^3;
                    
                    % Calc RPA = 1/x * integral (V*A_plus) dt ?
                    v = DataIn.sub(sub).cond(cond).Sections.Highway{rep}.Speed.raw./3.6;
                    a = DataIn.sub(sub).cond(cond).Sections.Highway{rep}.LongAcc.raw;
                    x = DataIn.sub(sub).cond(cond).Sections.Highway{rep}.DistanceTravelled.raw(end);
                    
                    VA_raw = v.*a;
                    ID_plus = find(a>0);
                    ID_min = find(a<=0);
                    VA = VA_raw;
                    VA(ID_min) = 0;
                    
                    HW.RPA(sub,cond,rep) = (sum(mean([VA(1:end-1)';VA(2:end)'])*(1/Fs)))./(x*1000);                                 
                    HW.VA_squared_mean(sub,cond,rep)  = mean(VA_raw.^2);
                    HW.VA_mean(sub,cond,rep)  = mean(VA_raw);
                    HW.perc_abs_Acc_LargerThan_2_5(sub,cond,rep)  = length(find(abs(a)>2.5))/(length(a)/Fs);
                    HW.perc_Speed_LT_110(sub,cond,rep)  = length(find(v>(110/3.6)))/(length(v)/Fs);
                    HW.EngineRPM_Mean(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Highway{rep}.EngineRPM.mean;
                end
            end
            
            NumMT_Sections = length(DataIn.sub(sub).cond(cond).Sections.Mountain);
            if ~isempty(NumMT_Sections)
                for rep = 1:NumMT_Sections       % MT
                    MT.Mean_ECO(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.ECO.mean;
                    MT.SRR(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.SWA.reversal_rate;
                    MT.Speed(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.Speed.mean;
                    MT.Speed_SD(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.Speed.std;
                    MT.GRR(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.GP.reversal_rate;
                    MT.BRR(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.BrakePressure.reversal_rate;
                    MT.p75_abs_LongAcc(sub,cond,rep) = prctile(abs(DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.LongAcc.raw),75);
                    MT.p75_abs_LatACC(sub,cond,rep) = prctile(abs(DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.LatAcc.raw),75);
                    %MT.LongAccRR(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.LongAcc.reversal_rate;
                    MT.Brake_SD(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.BrakePressure.std;
                    MT.SWA_SD(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.SWA.std;
                    MT.GP_SD(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.GP.std;
                    
                    MT.GP(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.GP.mean;
                    MT.Mean_abs_SWA(sub,cond,rep) = mean(abs(DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.SWA.raw));
                    MT.Mean_abs_SWA_speed(sub,cond,rep) = mean(abs(DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.SWA_Speed.raw));
                    MT.p50_abs_SWA_speed(sub,cond,rep) = prctile(abs(DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.SWA_Speed.raw),50);
                    MT.p10_abs_SWA_speed(sub,cond,rep) = prctile(abs(DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.SWA_Speed.raw),10);
                    MT.p50_SWA_speed(sub,cond,rep) = prctile(DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.SWA_Speed.raw,50);
                    MT.p99_BP(sub,cond,rep) = prctile(abs(DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.BrakePressure.raw),99);
                    MT.LongAcc_SD(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.LongAcc.std;
                    MT.LatAcc_SD(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.LatAcc.std;
                    MT.GP_percentage_above_90(sub,cond,rep) =  length(find(DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.GP.raw > 90))...
                        /length(DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.GP.raw)*100;
                    MT.p90_GP(sub,cond,rep) = prctile(abs(DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.GP.raw),90);
                    MT.Mean_FuelConsumption_psec(sub,cond,rep) = (DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.FuelConsumption_Cum.raw(end)./...
                        (length(DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.FuelConsumption_raw.raw)/Fs))/1000; % mm^3 --> cm^3;
                    MT.Mean_FuelConsumption_pkm(sub,cond,rep) = (DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.FuelConsumption_Cum.raw(end)./...
                        DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.DistanceTravelled.raw(end))/1000; % mm^3 --> cm^3;
                    MT.Total_FuelConsumption(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.FuelConsumption_Cum.raw(end)/1000; % mm^3 --> cm^3;
                    
                    % Calc RPA = 1/x * integral (V*A_plus) dt ?
                    v = DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.Speed.raw./3.6;
                    a = DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.LongAcc.raw;
                    x = DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.DistanceTravelled.raw(end);
                    
                    VA_raw = v.*a;
                    ID_plus = find(a>0);
                    ID_min = find(a<=0);
                    VA = VA_raw;
                    VA(ID_min) = 0;
                    
                    MT.RPA(sub,cond,rep) = (sum(mean([VA(1:end-1)';VA(2:end)'])*(1/Fs)))./(x*1000);  
                    MT.VA_squared_mean(sub,cond,rep) = mean(VA_raw.^2);
                    MT.VA_mean(sub,cond,rep) = mean(VA_raw);
                    MT.perc_abs_Acc_LargerThan_2_5(sub,cond,rep) = length(find(abs(a)>2.5))/(length(a)/Fs);
                    MT.perc_Speed_LT_110(sub,cond,rep) = length(find(v>(110/3.6)))/(length(v)/Fs);
                    MT.EngineRPM_Mean(sub,cond,rep) = DataIn.sub(sub).cond(cond).Sections.Mountain{rep}.EngineRPM.mean;
                end
            end
        end
    end
    
    %% Mean all the values into one value.
    % So HW is driven 22 times, you take the average over these 22 values
    FieldNames = fields(MT);    
    for i = 1:length(FieldNames)
        eval(sprintf('HW_out.%s = mean(HW.%s,3,''omitnan'');',FieldNames{i},FieldNames{i})); % To get the mean for all participants over all rep
        eval(sprintf('MT_out.%s = mean(MT.%s,3,''omitnan'');',FieldNames{i},FieldNames{i})); % To get the mean for all participants over all rep
        % Create into one matrix (4xnr_subjects)
        % Structured as [1. HW Norm, 2. MT Norm, 3. HW ECO, 4. MT ECO]
        eval(sprintf('DataOut.%s{Vn} = [HW_out.%s(:,1) MT_out.%s(:,1) HW_out.%s(:,2) MT_out.%s(:,2)];',FieldNames{i},FieldNames{i},FieldNames{i},FieldNames{i},FieldNames{i}));
    end
    HW_temp_rank.Vn{Vn}.Fuel = mean(HW.Total_FuelConsumption,3,'omitnan');
    MT_temp_rank.Vn{Vn}.Fuel = mean(MT.Total_FuelConsumption,3,'omitnan');
end

%% Create Ranking
% Zou ook per rit kunnen, nu is het per bestuurder
 HW_rank = [HW_temp_rank.Vn{1}.Fuel; HW_temp_rank.Vn{2}.Fuel];
 maxHW = sum(sum(~isnan(HW_rank))); %128
 HW_Out_rank = reshape(tiedrank(reshape(HW_rank,364,1)),length(HW_rank),2);

 MT_rank = [MT_temp_rank.Vn{1}.Fuel; MT_temp_rank.Vn{2}.Fuel];
 maxMT = sum(sum(~isnan(MT_rank))); %94
 MT_Out_rank = reshape(tiedrank(reshape(MT_rank,364,1)),length(MT_rank),2);
 
 % Structured as [1. HW Norm, 2. MT Norm, 3. HW ECO, 4. MT ECO]
 DataOut.Fuel_Rank{1} = [HW_Out_rank(1:91,1) MT_Out_rank(1:91,1) HW_Out_rank(1:91,2) MT_Out_rank(1:91,2)];
 DataOut.Fuel_Rank{2} = [HW_Out_rank(92:end,1) MT_Out_rank(92:end,1) HW_Out_rank(92:end,2) MT_Out_rank(92:end,2)];
end
