%% Plot_average_results
disp('Creating Figure 2')
tick_labels{1} = {'HW_{normal}','MT_{normal}','HW_{ECO}','MT_{ECO}'};
tick_labels{2} = {'Megane','Clio'}; % repetition labels
x_label     = 'Task';
BoxOrCI = 'CI'; % CI or BOX
plt_individual_lines = false;

%% Plot figure 2
figure()
subplot(1,3,1); hold on;
% ECO
y_label = 'Mean ECO (%)';
plt_error_bars( PltData.Mean_ECO,  x_label, y_label, tick_labels ,BoxOrCI,plt_individual_lines);
ylim([0 100])

subplot(1,3,2); hold on;
% Fuel consumption diff per km
y_label = 'Mean Fuel consumption (cm^3/km)';
plt_error_bars( PltData.Mean_FuelConsumption_pkm,  x_label, y_label, tick_labels ,BoxOrCI,plt_individual_lines);

subplot(1,3,3); hold on;
% Mean Speed
y_label = 'Speed (km/h)';
plt_error_bars( PltData.Speed,  x_label, y_label, tick_labels ,BoxOrCI,plt_individual_lines);

%% Create statistics table

% Effect odriving task
% [1. HW Norm, 2. MT Norm, 3. HW ECO, 4. MT ECO]
% Ordered as: Vehicle Y(columnum1) Vehilce Y(ColumnNum2)
EffectDT      = [1 1 1 3;... % So here compare vehicle 1 HW norm (num 1) with vehicle 1 HW ECO (num 3)
    1 2 1 4;...
    2 1 2 3;...
    2 2 2 4];
EffectRoute   = [1 1 1 2;... % Effect of route
    1 3 1 4;...
    2 1 2 2;...
    2 3 2 4];
EffectVehicle = [1 1 2 1;... % Effect of vehicle
    1 2 2 2;...
    1 3 2 3;...
    1 4 2 4];

CohensD_Total = {EffectDT EffectRoute EffectVehicle};

MeasuresList = {'Mean_ECO',...
    'Mean_FuelConsumption_pkm',...
    'Mean_FuelConsumption_psec',...
    'VA_squared_mean', ...
    'RPA', ...
    'Speed',... % Mean Speed
    'Speed_SD',...
    'p75_abs_LongAcc',...
    'LongAcc_SD',...
    'GP',...
    'GP_SD',...
    'p90_GP',...
    'p75_abs_LatACC',...
    'LatAcc_SD',...
    'SRR',...
    'Mean_abs_SWA',...
    'Mean_abs_SWA_speed'}';

% create matrix with values
counter = 1;
%TableTotal = ;
for i = 1:length(MeasuresList)
    eval(sprintf('Y = PltData.%s;',MeasuresList{i}));
    Y_m{1} = mean(Y{1},'omitnan');
    Y_m{2} = mean(Y{2},'omitnan');
    Y_SD{1} = std(Y{1},'omitnan');
    Y_SD{2} = std(Y{2},'omitnan');
        
    % Calculate cohen's d for all three directions
    for EffectDir = 1:length(CohensD_Total)
            % Do the cohen's d comparision for all 4 comparisons
        for jj = 1:length(EffectDT)
            % the Compare matrix with the comparisons according to the above
            % mentioned comparisons
            Cm = CohensD_Total{EffectDir}(jj,:);
            SD_pool_mean = sqrt(1/2*(Y_SD{Cm(1)}(Cm(2))).^2 + ...
                1/2*(Y_SD{Cm(3)}(Cm(4))).^2);
            Y_CohenD(jj) = (Y_m{Cm(1)}(Cm(2)) - Y_m{Cm(3)}(Cm(4)))/ SD_pool_mean;
        end
        CohenD_Average_total(EffectDir) = mean(Y_CohenD);
    end
    % put in one table
    TableTotal(counter,:) = [Y_m{1}(1) Y_m{2}(1) ... % {1} = megane {2} = clio
        Y_m{1}(2) Y_m{2}(2) ...
        Y_m{1}(3) Y_m{2}(3) ...
        Y_m{1}(4) Y_m{2}(4) ...
        abs(CohenD_Average_total)]; % add cohen's d behind it
    counter = counter + 1;
    TableTotal(counter,:) = [Y_SD{1}(1) Y_SD{2}(1) ...
        Y_SD{1}(2) Y_SD{2}(2) ...
        Y_SD{1}(3) Y_SD{2}(3) ...
        Y_SD{1}(4) Y_SD{2}(4) ...
        NaN NaN NaN]; % add cohen's d behind it
    counter = counter + 1;
end