function clean_data = removeBadData(variable)

%% 1. get rid of bad data, this happens sometimes when no data was logged

if(~isempty(find(isnan(variable),1))) % first, find bad data
    try
    %disp('Found some corrupted data. Interpolating to replace');
    % then interpolate between missing data points to make up
    xi = [1:1:length(variable)];
    corrupt = find(isnan(variable));
    x = xi; Y = variable;
    x(corrupt) = [];
    Y(corrupt) = [];
    variable=interp1(x,Y,xi,'spline','extrap');
    catch
       warning('Timo in RemoveBadData: Not able to interpolate --> often corrupted data!')
    end
end

clean_data = variable;

end
